<?php

function pln($response)
{
    $ci = &get_instance();
    $ci->load->helper('fcm');

    //DIGIFLAZZ
    $ref_id =  $response['ref_id'];
    $rc =  $response['rc'];
    $status =  $response['status'];
    $sn =  $response['sn'];
    $desc = $response['desc'];
    $lembar_tagihan = $desc['lembar_tagihan'];
    if ($lembar_tagihan == "1") {
        $detail = $desc['detail'][0];
        $meter_awal = ltrim($detail['meter_awal'], '0');
        $meter_akhir = ltrim($detail['meter_akhir'], '0');
    } else {
        //TAGIHAN 1
        $detail_satu = $desc['detail'][0];
        $meter_awal = ltrim($detail_satu['meter_awal'], '0');

        //TAGIHAN 2
        $detail_dua = $desc['detail'][1];
        $meter_akhir = ltrim($detail_dua['meter_akhir'], '0');
    }

    //PLN
    if (strtok($ref_id, "-") == "PLN") {

        //KATEGORI TRANSAKSI
        $trx_transaksi_kategori =  $ci->config->item('transaksi_pln');

        //PANGGIL TRANSAKSI
        $pln = $ci->db->query("SELECT * FROM tbl_trx_pln WHERE trx_pln_kode='$ref_id'");
        if ($pln->num_rows() > 0) {
            foreach ($pln->result() as $row) {
                $trx_pln_user_kode = $row->trx_pln_user_kode;
                $trx_pln_nomor = $row->trx_pln_nomor;
                $trx_pln_nama = $row->trx_pln_nama;
                $trx_pln_admin = $row->trx_pln_admin;
                $trx_pln_total = $row->trx_pln_harga + $row->trx_pln_admin;
                $trx_pln_tanggal = $row->trx_pln_tanggal;
                $trx_pln_rc = $row->trx_pln_rc;
            }

            //TRANSAKSI BERHASIL
            if ($rc == '00') {
                //JIKA TRANSAKSI MASIH PENDING
                if ($trx_pln_rc == '03' || $trx_pln_rc == '00') {
                    //UPDATE tbl_trx_pln
                    $ci->db->query("UPDATE tbl_trx_pln set 
                                trx_pln_meter_awal='$meter_awal',
                                trx_pln_meter_akhir='$meter_akhir',
                                trx_pln_rc='$rc',
                                trx_pln_status='$status',
                                trx_pln_notasi='Terbitnya kode SN merupakan bukti pembayaran tagihan sukses',
                                trx_pln_sn='$sn'
                                where
                                trx_pln_kode='$ref_id' and
                                trx_pln_user_kode='$trx_pln_user_kode'");

                    //UPDATE STATUS tbl_trx_transaksi
                    $ci->db->query("UPDATE tbl_trx_transaksi set 
                                trx_transaksi_notasi='',
                                trx_transaksi_rc='$rc', 
                                trx_transaksi_status='$status'
                                where
                                trx_transaksi_kode='$ref_id' and
                                trx_transaksi_user_kode='$trx_pln_user_kode'");


                    //INSERT KE tbl_trx_pendapatan
                    $ci->db->query("insert into tbl_trx_pendapatan (
                                trx_pendapatan_kode, 
                                trx_pendapatan_user_kode, 
                                trx_pendapatan_kategori, 
                                trx_pendapatan_jumlah, 
                                trx_pendapatan_tanggal) values (
                                '$ref_id', 
                                '$trx_pln_user_kode', 
                                '$trx_transaksi_kategori',
                                '$trx_pln_admin', 
                                '$trx_pln_tanggal')");

                    //PANGGIL USER
                    $user = $ci->db->query("SELECT * FROM tbl_mst_user WHERE mst_user_kode='$trx_pln_user_kode'");
                    if ($user->num_rows() > 0) {
                        foreach ($user->result() as $row) {
                            $mst_user_firebase = $row->mst_user_firebase;
                            $mst_user_upline = $row->mst_user_upline;
                        }

                        //PANGGIL UPLINE
                        $upline = $ci->db->query("SELECT * FROM tbl_mst_user WHERE mst_user_kode='$mst_user_upline'");
                        if ($upline->num_rows() > 0) {
                            foreach ($upline->result() as $row) {
                                $mst_user_referal_bonus = $row->mst_user_referal_bonus;
                            }

                            //CEK UPLINE
                            if (strlen($mst_user_upline) > 0) {
                                //UPLINE BONUS
                                //INSERT KE tbl_trx_poin
                                $ci->db->query("insert into tbl_trx_poin (
                                         trx_poin_kode, 
                                         trx_poin_user_kode, 
                                         trx_poin_nama, 
                                         trx_poin_keterangan, 
                                         trx_poin_jumlah,
                                         trx_poin_tanggal) values (
                                         '$ref_id', 
                                         '$mst_user_upline', 
                                         'Downline',
                                         'Bonus dari transaksi downline', 
                                         '$mst_user_referal_bonus', 
                                         '$trx_pln_tanggal')");

                                //UPDATE tbl_mst_poin
                                $ci->db->query("UPDATE tbl_mst_poin set 
                                         mst_poin_jumlah=mst_poin_jumlah + '$mst_user_referal_bonus'
                                         where
                                         mst_poin_user_kode='$mst_user_upline'");
                            }
                        }

                        //KIRIM NOTIFIKASI
                        $title = "Arifah Pulsa";
                        $body =  "Pembayaran tagihan PLN berhasil ke nomor " . $trx_pln_nomor . " - " . $trx_pln_nama;
                        firebase_notification($title, $body, $mst_user_firebase);
                    }
                }
            } else {
                //TRANSAKSI GAGAL
                //JIKA TRANSAKSI MASIH PENDING
                if ($trx_pln_rc == '03') {
                    //UPDATE tbl_trx_pln
                    $ci->db->query("UPDATE tbl_trx_pln set 
                                trx_pln_rc='$rc',
                                trx_pln_status='$status',
                                trx_pln_notasi='Pembayaran tagihan PLN gagal, saldo kamu telah dikembalikan!',
                                trx_pln_sn='-'
                                where
                                trx_pln_kode='$ref_id' and
                                trx_pln_user_kode='$trx_pln_user_kode'");

                    //UPDATE STATUS tbl_trx_transaksi
                    $ci->db->query("UPDATE tbl_trx_transaksi set 
                                trx_transaksi_notasi='Pembayaran tagihan PLN gagal, saldo kamu telah dikembalikan!',
                                trx_transaksi_rc='$rc', 
                                trx_transaksi_status='$status'
                                where
                                trx_transaksi_kode='$ref_id' and
                                trx_transaksi_user_kode='$trx_pln_user_kode'");


                    //UPDATE tbl_mst_saldo
                    $ci->db->query("UPDATE tbl_mst_saldo set 
                                mst_saldo_jumlah=mst_saldo_jumlah + '$trx_pln_total'
                                where
                                mst_saldo_user_kode='$trx_pln_user_kode'");

                    //PANGGIL USER
                    $user = $ci->db->query("SELECT * FROM tbl_mst_user WHERE mst_user_kode='$trx_pln_user_kode'");
                    if ($user->num_rows() > 0) {
                        foreach ($user->result() as $row) {
                            $mst_user_firebase = $row->mst_user_firebase;
                            $mst_user_referal_bonus = $row->mst_user_referal_bonus;
                            $mst_user_upline = $row->mst_user_upline;
                        }

                        //KIRIM NOTIFIKASI
                        $title = "Arifah Pulsa";
                        $body =  "Pembayaran tagihan PLN gagal ke nomor " . $trx_pln_nomor . " - " . $trx_pln_nama . ". Saldo telah dikembalikan ke akun kamu";
                        firebase_notification($title, $body, $mst_user_firebase);
                    }
                }
            }
        }
    }
}
